
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何用 ANTLR 4 实现自己的脚本语言？ / iVAN</title>

    <meta name="description" content="如何用 ANTLR 4 实现自己的脚本语言？ ANTLR 是一个 Java 实现的词法/语法分析生成程序,目前最新版本为 4.5.2,支持 Java,C#,JavaScript 等语言,这里我们用 ANTLR 4.5.2 来实现一个自己的脚本语言. 因为某些未知原因,ANTLR 官方的文档似乎有些地方和 4.5.2 版的实际情况不太吻合,所以,有些部分,我们必须多方查找和自己实践得到,所幸 ANTLR 的文档比较丰富,其在 Github 上例子程序也很多,足够我们探索的了. 如果你没有编译原理的基础,只要写过正则表达式,应该也能很快理解其规">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何用 ANTLR 4 实现自己的脚本语言？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>ANTLR 是一个 Java 实现的词法/语法分析生成程序，目前最新版本为 4.5.2，支持 Java，C#，JavaScript 等语言，这里我们用 ANTLR 4.5.2 来实现一个自己的脚本语言。</strong></p>
<p>因为某些未知原因，ANTLR 官方的文档似乎有些地方和 4.5.2 版的实际情况不太吻合，所以，有些部分，我们必须多方查找和自己实践得到，所幸 ANTLR 的文档比较丰富，其在 Github 上例子程序也很多，足够我们探索的了。</p>
<p>如果你没有编译原理的基础，只要写过正则表达式，应该也能很快理解其规则，进而编写自己的规则文件，事实上，因为结构更清晰， ANTLR 的规则文件，比正则表达式要简单得多。</p>
<p>我使用 C# 版本，所以下载了 antlr-4.5.2-complete.jar 和 C# 的支持库 Antlr4.Runtime.dll。</p>
<p>ANTLR 官方网址 <a href="http://www.antlr.org/" rel="external nofollow noreferrer">http://www.antlr.org/</a><br />
ANTLR 官方 Github <a href="https://github.com/antlr/antlr4" rel="external nofollow noreferrer">https://github.com/antlr/antlr4</a><br />
大量语法文件例子 <a href="https://github.com/antlr/grammars-v4" rel="external nofollow noreferrer">https://github.com/antlr/grammars-v4</a><br />
因为文章中不适合贴全部的代码，建议下载了 TinyScript 的代码后，和此文章对照阅读和实践。</p>
<p>本文程序的 Github <a href="https://github.com/Lifeng-Liang/TinyScript" rel="external nofollow noreferrer">https://github.com/Lifeng-Liang/TinyScript</a><br />
好了，进入正题，我们要定义一个解释型的脚本语言，就起个名叫 TinyScript 好了，规则文件名 TinyScript.g4 ，简单起见，暂不实现函数，具体实现的功能如下：</p>
<p>变量，支持的数据类型为 decimal，bool，string，不支持 null<br />
变量赋值支持自动类型推断，用 var 标识<br />
四则运算，支持字符串通过 + 进行连接<br />
支持比较运算符，支持与或非运算符<br />
if 语句，语句块必须用大括号包裹<br />
while，do/while，for 循环，同样语句块必须用大括号包裹<br />
一个内置的输出函数 print，可以输出表达式的值到控制台<br />
先说四则运算。四则运算里，除了括号外，需要先乘除，后加减，这个规则在 ANTLR 里怎么实现呢？</p>
<p>在 ANTLR 里，我们写的规则，会生成解析器的代码，这个解析器，会把目标脚本，解析成一个抽象语法树。这颗抽象语法树上，越是靠近叶子节点的地方，结合优先级越高，越是靠近根的地方，结合优先级越低，根据这个特点，我们就可以让 ANTLR 帮我们完成以上的规则：</p>
<pre><code>addExpression
: mulExpression (('+' | '-') mulExpression)*
;
mulExpression
: primaryExpression (('<em>' | '/') primaryExpression)</em>
;
primaryExpression
: Decimal
| '(' addExpression ')'
;
</code></pre>
<p>上面展示的 ANTLR 规则，在 primaryExpression 中，包括两个可选项，要么是数字，要么是括号表达式，是最高优先级，然后是 mulExpression，优先级最低的是 addExpression 。括号表达式内，是一个 addExpression ，所以，这是一个循环结构，可以处理无限长的四则运算式，比如 1+2*3-(4+5)/6+7+8，会被解析为如下的语法树：</p>
<pre><code>addExpression : 1 + child1_1 - child1_2 + 7 + 8
child1_1 mulExpression : 2 * 3
child1_2 mulExpression : child1_2_1 / 6
child1_2_1 addExpression : 4 + 5
</code></pre>
<p>以上的语法树，其实是我简化了的，比如，其中的数字 1 其实应该是 ·mulExpression ，而这个 mulExpression 只有一项 primaryExpression，而这个 primaryExpression，是 Decimal，其值为 1 。</p>
<p>PS: 在 ANTLR 中，大写字母开头的标识符，如上面的 Decimal，是词法分析器解析的，而小写字母开头的标识符，如 addExpression，是语法分析器解析的，它可以通过 override Visitor 的相应函数，改成我们自己的处理。因为缺省情况下，ANTLR 4 生成的是 listener，而我想要使用 visitor，所以命令行输入为：</p>
<pre><code>   java -jar C:\Projects\ScriptParser\ts\antlr-4.5.2-complete.jar -visitor -no-listener TinyScript.g4
</code></pre>
<p>用上面的命令生成代码后，我们需要知道怎么才能启动它，可惜这里，至少对于 C#，文档写的要么不全，要么不正确，最后，我找到了正确的打开方式：</p>
<pre><code>using (var ais = new AntlrInputStream(new FileStream(fileName,     FileMode.Open)))
{
var lexer = new TinyScriptLexer(ais);
var tokens = new CommonTokenStream(lexer);
var parser = new TinyScriptParser(tokens);
parser.BuildParseTree = true;
var tree = parser.program();
var visitor = new MyVisitor();
visitor.Visit(tree);
}
</code></pre>
<p>上面的 MyVisitor，是我们需要实现的，它从生成的 TinyScriptBaseVisitor 继承， TinyScriptBaseVisitor 是个泛型类，研究后，它的泛型参数是设计用来传递返回值的，因为要支持多种数据类型，所以我把它定义为 object 。</p>
<p>在实现 MyVisitor 时，只要每个节点都做好自己的工作就可以了。下面我们以 VisitMulExpression 函数来简单介绍一下如何实现乘除运算：</p>
<pre><code>public override object VisitMulExpression([NotNull]     TinyScriptParser.MulExpressionContext context)
{
var a = VisitPrimaryExpression(context.primaryExpression(0));
for (int i = 1; i &lt; context.ChildCount; i += 2)
{
var op = context.GetChild(i).GetText();
var b =     (decimal)VisitPrimaryExpression((TinyScriptParser.PrimaryExpressionContext)context.GetChild(i + 1));
switch (op)
{
case "*":
a = (decimal)a * b;
break;
case "/":
a = (decimal)a / b;
break;
}
}
return a;
}
</code></pre>
<p>因为 mulExpression 的定义中，至少有一个 primaryExpression，然后，可以有任意多乘除运算符及相应的 primaryExpression ，对应在 VisitMulExpression 函数中，就是第一个子节点是 primaryExpression ，（如果有的话）第二个子节点是运算符，第三个子节点是 primaryExpression，第四个子节点是运算符……所以，上面的代码，先通过 VisitPrimaryExpression 取出第一个节点值，保存在变量 a 中，然后，通过循环获取运算符和另一个值，并进行相应的运算，并把结果保存在 a 中，最后把运算结果 a 返回。因为在 VisitMulExpression 中，只会处理乘除运算，它们是同等的优先级，我们也就不用考虑这个问题，直接运算下去就可以了。</p>
<p>要注意的是，如果 mulExpression 只有一个 primaryExpression 节点，它就不一定是 decimal ，所以 a 的类型是 object ，而在进行运算时，才会把它强制类型转换成 decimal，因为这时我们已经确定它是 decimal 类型了。</p>
<p>PS：在这里，我们有两种方式取得子节点的值，如果定义中用了标识符，就可以直接使用这个标识符名作为函数调用，如上面的 context.primaryExpression(0) ，表示取第一个 primaryExpression ；另一种方法是调用 GetChild 函数，GetChild 函数因为是通用函数，所以经常需要强制类型转换为我们需要的类型。</p>
<p>下面，我们来说说变量定义及自动类型推断。</p>
<p>为了实现变量，我们在我们的 Visitor 中定义一个 Dictionary 类型的变量 Variables ，用来保存变量和它的值，在 VisitDeclareExpression 函数中，根据变量类型，在 Variables 中插入相应的键值对，然后，在赋值时，检查要被赋值的表达式的值的类型，是否和 Variables 中的一致，如果不一致，则抛出异常。</p>
<pre><code>public override object VisitAssign([NotNull] TinyScriptParser.AssignContext     context)
{
var name = context.Identifier().GetText();
object obj;
if (!Variables.TryGetValue(name, out obj))
{
throw context.Exception("Variable [{0}] should be definded first.", name);
}
var r = base.VisitAssign(context);
if (obj != null)
{
if (obj.GetType() != r.GetType())
{
throw context.Exception("Cannot assign [{1}] type value to a variable with  type [{0}].", obj.GetType().Name, r.GetType().Name);
}
}
Variables[name] = r;
return null;
}
</code></pre>
<p>当然，我们也可以选择不在乎赋值语句两边是否类型相同，这样，它的行为方式就和很多脚本语言如 JavaScript 比较类似，变量在使用中可以改变类型。</p>
<p>不知道你是否注意到了，在上面的描述中，我们说到，我们其实知道表达式的结果的类型，并能在类型不匹配的时候抛出异常，那么，如果我们选择在定义类型时，如果变量类型是 var 的话，我们就不处理类型不匹配的问题，就是实现了自动类型推断！有点小颠覆吧？似乎很高级的这个语言特性，其实是顺理成章就可以得到的，不需要什么高大上的技术。在我们的脚本里，要做到这一点，只要在 VisitDeclareExpression 函数中，遇到 var 时，在插入变量时，变量值是 null 就可以了。</p>
<p>下面，我们再来看看 if 语句的处理，我们顶一个一个必须用大括号包裹的语句组类型 blockStatement ， if 语句定义如下：</p>
<pre><code>ifStatement
: 'if' quoteExpr blockStatement
| 'if' quoteExpr blockStatement 'else' blockStatement
;
</code></pre>
<p>当然，其实，上面的定义和下面这种写法是等价的：</p>
<pre><code>ifStatement
: 'if' quoteExpr blockStatement ('else' blockStatement)?
;
</code></pre>
<p>然后，我们在 VisitIfStatement 函数中，真的写一个 if 语句，用来执行不同的 blockStatement 就可以了：</p>
<pre><code>public override object VisitIfStatement([NotNull]     TinyScriptParser.IfStatementContext context)
{
var condition = (bool)VisitQuoteExpr(context.quoteExpr());
if (condition)
{
VisitBlockStatement(context.blockStatement(0));
}
else if (context.ChildCount == 5)
{
VisitBlockStatement(context.blockStatement(1));
}
return null;
}
</code></pre>
<p>最后那个 return null 是表明，我们的 if 语句不产生任何值。加上对 Visitor 内取值遍历等的理解，这个 if 语句的处理是否看起来非常清晰明了？</p>
<p>最后，来看看循环语句，我们以 for 循环为例，先看定义：</p>
<pre><code>forStatement
: 'for' '(' commonExpression ';' expression ';' assignAbleStatement ')'   blockStatement
;
</code></pre>
<p>再看实现：</p>
<pre><code>public override object VisitForStatement([NotNull] TinyScriptParser.ForStatementContext context)
{
for (VisitCommonExpression(context.commonExpression());
(bool)VisitExpression(context.expression());
VisitAssignAbleStatement(context.assignAbleStatement()))
{
VisitBlockStatement(context.blockStatement());
}
return null;
}
</code></pre>
<p>嗯，你没看错，我们真的用了一个 for 循环来实现 for 循环 :slight_smile:</p>
<p>好了，如果你下载了整个程序，并编译成功，我们现在可以编写一些脚本来做测试了，比如下面这个计算 1 到 100 的和的程序 sum.ts ：</p>
<pre><code>var sum = 0;
for(var i=1; i&lt;=100; i=i+1) {
sum = sum + i;
}
print("sum 1 to 100 is : " + sum);
</code></pre>
<p>运行 ts sum.ts ，控制台输出：</p>
<pre><code>sum 1 to 100 is : 5050
</code></pre>
<p>当然，这个脚本语言功能还比较弱，比如不支持函数，比如字符串不支持转义符等；也有一些实现的不太严格地方，比如强制类型转换如果出错，出错信息不准确等。不过，它是一个好的开始，可以让我们在此基础上，设计更完善、易用的语言。</p>
<p><strong><a href="http://www.oneapm.com/?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E5%A6%82%E4%BD%95%E7%94%A8%20ANTLR%204%20%E5%AE%9E%E7%8E%B0%E8%87%AA%E5%B7%B1%E7%9A%84%E8%84%9A%E6%9C%AC%E8%AF%AD%E8%A8%80%EF%BC%9F&amp;utm_content=wk328-403&amp;utm_campaign=AiJavaArti&amp;from=jscljdkkhc" rel="external nofollow noreferrer">OneAPM</a> 为您提供端到端的 <a href="http://www.oneapm.com/ai/java.html?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E5%A6%82%E4%BD%95%E7%94%A8%20ANTLR%204%20%E5%AE%9E%E7%8E%B0%E8%87%AA%E5%B7%B1%E7%9A%84%E8%84%9A%E6%9C%AC%E8%AF%AD%E8%A8%80%EF%BC%9F&amp;utm_content=wk328-403&amp;utm_campaign=AiJavaArti&amp;from=jscljdkkhc" rel="external nofollow noreferrer">Java 应用性能</a>解决方案，我们支持所有常见的 Java 框架及应用服务器，助您快速发现系统瓶颈，定位异常根本原因。分钟级部署，即刻体验，<a href="http://www.oneapm.com/ai/java.html?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E5%A6%82%E4%BD%95%E7%94%A8%20ANTLR%204%20%E5%AE%9E%E7%8E%B0%E8%87%AA%E5%B7%B1%E7%9A%84%E8%84%9A%E6%9C%AC%E8%AF%AD%E8%A8%80%EF%BC%9F&amp;utm_content=wk328-403&amp;utm_campaign=AiJavaArti&amp;from=jscljdkkhc" rel="external nofollow noreferrer">Java 监控</a>从来没有如此简单。想阅读更多技术文章，请访问 <a href="http://news.oneapm.com/?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E5%A6%82%E4%BD%95%E7%94%A8%20ANTLR%204%20%E5%AE%9E%E7%8E%B0%E8%87%AA%E5%B7%B1%E7%9A%84%E8%84%9A%E6%9C%AC%E8%AF%AD%E8%A8%80%EF%BC%9F&amp;utm_content=wk328-403&amp;utm_campaign=AiJavaArti&amp;from=jscljdkkhc" rel="external nofollow noreferrer">OneAPM 官方技术博客</a>。</strong></p>
<p><strong>本文转自 <a href="http://news.oneapm.com/" rel="external nofollow noreferrer">OneAPM 官方博客</a></strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 17:22:07</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/java%e7%9b%91%e6%8e%a7/" title="Java监控">Java监控</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何用 ANTLR 4 实现自己的脚本语言？的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjmLB6z.html" rel="bookmark">如何用PhotoShop脚本语言处理图片教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				利用Ps脚本我们可以简化工作流程,甚至能创造出让人震惊的数字艺术.卓越的设计师不是沉迷于幻想,而是将幻想变为现实的人.而技术,则是你的魔术棒... 原文作者Ross Aitken(个人教程站:http://psdlearning.com/) 这篇文章写得很详细,力图让每一个读者都能看懂.本文主要涉及到三块主要技术:调色.添加边框和阴影以及随机旋转.调色的方法是复制图片图层,然后平均模 糊取得该图片的平均色,其后用图片RGB通道直方图校验的方法取得该平均色的色值,并根据各通道颜色比例作出调整,然后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5NrO6z.html" rel="bookmark">脚本语言 java vbs-各位大神，请问如何用脚本语言在word上进行连线操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 各位大神,请问如何用脚本语言在word上进行连线操作 解决方案 用word录一个宏,看看宏代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LzJ3Aqb.html" rel="bookmark">图形脚本语言sikuli</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介                                                                                                                                                                                                                                                       			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrdROz.html" rel="bookmark">关注web编程语言和脚本语言的就业趋势</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				八月是一个值得关注工作趋势的月份,今天,我们来重点关注web编程语言和脚本语言的就业趋势. 您可能很想知道我所指的&quot;web编程语言和脚本语言&quot;到底是什么?本文中我列举了Ruby.Python.PHP.JavaScript.Flex 以及 Groovy等编程语言.我在这里并没有提及Rails,是因为我想尽量将开发框架和开发语言区分开. 1. Indeed.com趋势分析图:(横坐标表示时间:纵坐标表示所匹配工作岗位的百分比) 同其它语言相比,JavaScript的需求量最大,但是在过去六			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyyvlM.html" rel="bookmark">photoshop动作自动化脚本语言教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自动化对每个设计师的工作来说是很有用的.它可以在重复的任务上节省宝贵的时间,还能够帮我们更快捷.更容易的解决一系列问题. 你可以使用photoshop的动作来使工作流程自动化,这是很流行的,大多数人都知道并且已经在使用的方法.今天,我们将介绍给你一种高级的自动化技巧:脚本语言.所有的这一切仅仅需要你有一点点关于JavaScript的基本知识,这对于我们中的一些网页设计师往往都是具备的. 我很多年前就知道Photoshop的脚本语言,但是我几个月前才开始决定研究它.我忽视了它是因为我认为那是聪明的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMNL8Wz.html" rel="bookmark">将PHP作为Shell脚本语言使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				脚本 本文出自:http://phpuser.com 作者: y10k翻译 (2002-10-15 06:02:00) --英文原著:Darrell Brogdon,发表于 http://www.phpbuilder.com/columns/darrell20000319.php3) 可能很多人都想过使用PHP编写一些定时发信之类的程序,但是却没有办法定时执行PHP:一次去PHPBuilder的时候,发现了这一篇文章,于是想给大家翻译一下(同时做了一些修改),希望对大家有用.第一次翻译文章,不好			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyOPEz.html" rel="bookmark">将Delphi作为ASP&period;NET的脚本语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|脚本    将Delphi视为脚本语言       支持ASP.net的第一件事是让ASP.NET将Delphi视为脚本语言,让ASP.NET能够为各种ASP文件类型调用Delphi的.NET编译器.       ASP.NET要在IIS虚路径的根目录下寻找Web.config文件.下面是ASP.NET中使用Delphi作脚本语言的web.config配制文件内容:       &lt;configuration&gt;    &lt;system.web&gt;    &lt;compi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMro1xp.html" rel="bookmark">选择合适的java脚本语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				脚本 选择合适的java脚本语言--如果你正考虑在java应用中集成脚本解释器,最难得是决定使用那种 摘要:脚本语言已经向java开发者证明了它的价值.它让客户实现应用功能的扩展和界面的个性化,从而程序的价值得以提升.另外,它们可以显著的简化程序开发者的设计任务,通过实现动态定义.装载和评估.对于开发人员,集成一种或多种脚本语言的任务是简单的,从越来越长的可选列表中选出一个确实困难的.本文描述了一些伴随java应用中脚本语言支持的问题,并从不同角度比较了Groovy, JudoScript, P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeWPVM.html" rel="bookmark">用&period;net &lpar;在IIS中&rpar;创建虚拟目录&lpar;包括 脚本语言&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iis|创建|脚本|虚拟目录 两种语言在IIS中创建虚拟目录 用.net在IIS中创建虚拟目录 使用.NET的目录服务就可以访问IIS的设置,添加虚拟目录其实就是创建一个DirectoryEntry复杂的在于DirectoryEntry的属性,其实就是虚拟目的一些配置,比如,权限,是否要log,应用程序名等Properties非常多,而且文档不太好找详细可以参考MSDN以下内容help://MS.MSDNQTR.2004JUL.1033/iissdk/iis/configuring_proper			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBXdKp.html" rel="bookmark" class="title">当PHP遇到MySQL存储过程</a>
					<div>
						1.MySQL存储过程 我们常用的操作数据库语言SQL语句在执行的时候需要要先编译,然后执行,而存储过程(Stored Procedure)是一组为了完成特定功能的SQL语句集,经编译后存储在数据库中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYvw9p.html" rel="bookmark" class="title">ASPX中的用户控件与ASP中的INCLUDE方法对比</a>
					<div>
						include|控件     在ASP的年代里,为了避免经常性重复的劳动,对一些功能相似的区域或者代码,经常作成一个文件,然后通过连接(直接连接或者虚拟连接)的方法引入到ASP网页文件之中,对于一个很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6aVLb.html" rel="bookmark" class="title">XML Litmus 测试</a>
					<div>
						xml Dare Obasanjo 提供了一些简单的指南,用于确定 XML 作为适当的技术何时用于软件应用程序或架构设计中. 点击此处阅读全文					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBxoKp.html" rel="bookmark" class="title">IIS6里如何激活asp</a>
					<div>
						iis http://forums.zdnet.com.cn/cgi-bin/view.cgi?forum=1&amp;topic=1086					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnWQVz.html" rel="bookmark" class="title">vc&period;net中实现启动画面淡入淡出</a>
					<div>
						找了半天没找实现启动画面来个淡入淡出的代码,只好自己写了个,呵呵,还不错拿给大家看看. #undef WINVER //取消原有版本定义,重新定义版本 #define WINVER 0x5000 // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK70NEb.html" rel="bookmark" class="title">Sophos杀毒软件如何抵御Skype新变种蠕虫的</a>
					<div>
						Sopho认为近日爆发的Skype新蠕虫再次强调了先期病毒防御的重要性.通过Skype即时通信系统传播的蠕虫没有能够攻击Sophos用户,Sophos先期防御在没有要求更新生升级的情况下成功抵抗了病毒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKWwmM.html" rel="bookmark" class="title">C语言的预处理程序与注释</a>
					<div>
						C程序的源代码中可包括各种编译指令,这些指令称为预处理命令.虽然它们实际上不是C语言的一部分,但却扩展了C程序设计的环境.本节将介绍如何应用预处理程序和注释简化程序开发过程,并提高程序的可读性.4.7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NPkwz.html" rel="bookmark" class="title">FSO组件之CreateTextFile方法介绍</a>
					<div>
						object.CreateTextFile(filename[, overwrite[, unicode]]) 参数:object 必选项. 应为 FileSystemObject 或 Folder  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Pk5mM.html" rel="bookmark" class="title">Python3通过Luhn算法快速验证信用卡卡号的方法</a>
					<div>
						  本文实例讲述了Python3通过Luhn算法快速验证信用卡卡号的方法.分享给大家供大家参考.具体分析如下: Python3通过Luhn算法快速验证信用卡卡号,python用起来就是爽,很简单的三行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oAAnb.html" rel="bookmark" class="title">巧设Word 2007无滚轮自动卷动</a>
					<div>
						  有些老式的两键鼠标是没有滚轮的,因此在使用Word时往往要移到窗口右边拖动垂直滚动条来实现较长的个人简历表格文章翻页,十分不便.那么有没有较好的方法可以用来滚动页面查看文件呢? 其实,从Word  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBYXDz.html" rel="bookmark" class="title">U盘拔出后win7系统自动关机的原因</a>
					<div>
						  原因1: 可能是U盘传染了病毒,所以导致电脑也中毒了. 解决方案: 1.重启计算机,然后在计算机加载完BIOS界面后,迅速在键盘上按下F8; 2.之后会进入高级选项菜单,通过键盘上的方向键上下移动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw8wnb.html" rel="bookmark" class="title">电脑右键打开方式消失了怎么办</a>
					<div>
						  1.首先我们打开桌面的开始菜单,看到栏目中的运行点击打开,打开后输入命令regedit,直接回车键就可以打开注册表编辑器了; 2.打开了注册表编辑器的窗口,在窗口左侧开始打开路径为HKEY_CLA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJk3jDb.html" rel="bookmark" class="title">断点-&period;net站点本地功能好用，发布以后部分功能不起作用</a>
					<div>
						问题描述 .net站点本地功能好用,发布以后部分功能不起作用 MVC框架下的一个后台管理系统.一个列表搜索功能,有几个下拉框.其中一个是可下拉选择 并且支持手动输入的.就是这个支持手动输入的文本框,有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP9glp.html" rel="bookmark" class="title">《Adobe Illustrator CS5中文版经典教程》目录&mdash;导读</a>
					<div>
						版权声明 Adobe Illustrator CS5中文版经典教程 Authorized translation from the English language edition, entitled ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE96mz.html" rel="bookmark" class="title">MFC读txt数据时，数据出错</a>
					<div>
						问题描述 MFC读txt数据时,数据出错 我用mfc写了一个程序用于读取数据进行一元线性回归计算,读进来的数据总会莫名其妙的出问题,比如数据是12.34,读进来就会变成12.3399999999999 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAEm2M.html" rel="bookmark" class="title">c&plus;&plus;-哪位大神能帮我讲解一下这个语句？id为什么是那么写的呢？</a>
					<div>
						问题描述 哪位大神能帮我讲解一下这个语句?id为什么是那么写的呢? id1=&quot;select manage_pwd,manage_name,manage_position from manag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDGr8z.html" rel="bookmark" class="title">datagridview-在dataview中选取一行显示在各个textbox中</a>
					<div>
						问题描述 在dataview中选取一行显示在各个textbox中 foreach (int i in dataGridView1.CurrentRow.Index)//&quot;int&quot;不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AqAlz.html" rel="bookmark" class="title">暴风影音官方网站将删除播放软件所有版本的下载</a>
					<div>
						本报讯 (实习记者李斌)昨天,就&quot;暴风门&quot;断网事件,暴风影音方面首次正式召开&quot;说明会&quot;表示,公司将召回1.2亿旧版的播放软件,其官方网站将删除此前所有版本的下载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZN4Zp.html" rel="bookmark" class="title">loginaction-http  Status 500 app&period;action&period;LoginAction&period;index&lpar;&rpar;</a>
					<div>
						问题描述 http Status 500 app.action.LoginAction.index() HTTP Status 500 - app.action.LoginAction.index() ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqKE1b.html" rel="bookmark" class="title">防御性编码和单元测试规则</a>
					<div>
						开发人员编写代码.不幸的是,开发人员也编写缺陷,其中大多数缺陷是在最初的编码阶段加入的.修复这些缺陷成本最低的地方同样也是在开发的初始阶段.如果等到功能测试或者系统测试来捕获并修复缺陷,那么您的软件开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nvNDz.html" rel="bookmark" class="title">求指点：linq怎么对datatable的多个字段进行分组啊？</a>
					<div>
						问题描述 比如:有个datatable有四个字段:xian,xiang,cun,mianji想通过xianxiang分类统计面积linq语句怎么写啊? 解决方案 解决方案二:grouprbynew{x ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqYA4b.html" rel="bookmark" class="title">跨境电商爆发前夜 这三家公司告诉你如何运营</a>
					<div>
						导读: 跨境电商的模式主要有三种:B2C平台.自营B2C和海淘,代表企业分别是洋码头.蜜淘.hai360海外购. 洋码头是国内第一家引进海外零售商的跨境进口电商平台,中国消费者可以在网站上直接购买海外 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBRVwM.html" rel="bookmark" class="title">solr copyField 域怎么保存转化后的值</a>
					<div>
						问题描述 在solr配置文件中&lt;!--转小写类型--&gt;&lt;fieldTypename=&quot;lowercase&quot;class=&quot;solr.TextField&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnOY6M.html" rel="bookmark" class="title">C&sol;C&plus;&plus;中extern &amp;quot&semi;C&amp;quot&semi; 的作用分析&lowbar;C 语言</a>
					<div>
						我们经常会在C/C++程序中见到extern &quot;C&quot;,这是一个很重要的概念.本文就来以实例形式讲述C/C++中extern &quot;C&quot;的作用.分享给大家供大家参考之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7NOAM.html" rel="bookmark" class="title">客齐集OEM的CSS解析与开发经验&lowbar;经验交流</a>
					<div>
						客齐集OEM的CSS解析 这个OEM是客齐集推出来的,如果你有一个域名,那么你就可以定制自已的网站了.由于是要让站工自已定制,所以开放了HTML以及CSS.JS等代码.但默认的CSS是CSS是不能改的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba68jmM.html" rel="bookmark" class="title">电子商务威胁传统商业&amp;amp&semi;nbsp&semi;大卖场遭遇网络杀手</a>
					<div>
						         近日,金银岛网上一则1人也可团购的消息惊动了不少网民.依照其团购价,在国美要花6200元的一款联想笔记本,只需5600元就能买到,在苏宁MOTO E680i为3280元,而在金银岛上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYaQ8b.html" rel="bookmark" class="title">哪位大神可以帮帮我 让获得的数剧可以在主线程的ui中显示 我知道用handler但是写出来后没调用</a>
					<div>
						问题描述 publicclassMainActivityextendsActivity{ChannelScanEngineengine;List&lt;Sservice&gt;mlist1=newAr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QD9ap.html" rel="bookmark" class="title">有人在实际项目中用Entity Framework吗？</a>
					<div>
						问题描述 请问有人在实际项目中用EF吗,用得多不多?如果不用的话Model层怎么映射,全部手写吗? 解决方案 解决方案二: 该回复于2012-03-14 13:15:46被版主删除解决方案三: 我经常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NJgnz.html" rel="bookmark" class="title">javascript-Web前端JS计数器代码修改问题</a>
					<div>
						问题描述 Web前端JS计数器代码修改问题 这是一个js计时器的代码,目前只能向上滚动数字,我想改成向下滚动的应该怎么办呢,跪谢各位大神~ function DigitRoll(a){if(this. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJe38Jp.html" rel="bookmark" class="title">POI 导出合并列</a>
					<div>
						/** * 合并单元格相同的值 * @param wb * @param startRow 去除表头要合并的第一行index * @param columns 要合并的列的index */ priva ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
